//+------------------------------------------------------------------+
//|                                               CalcAverMaxDiv.mq4 |
//|                                    Copyright  2011, khorosh     |
//|                                                                  |
//|              |
//|                                    |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "khorosh"
#property link      ""
#property show_inputs
string Symb1 ;
extern string Symb2             = "CHFJPY";
extern int CountDay = 30;    //  - 
double p1,p2;
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
//----
Comment("");

double DivM,          //  
       CurrentDiv,    // 
       SumDivM,       //   
       SumDiv,        // 
       DivAver,       // 
       DivAverMax;    //   
Symb1=Symbol();       
p1 = MarketInfo(Symb1,MODE_POINT);
p2 = MarketInfo(Symb2,MODE_POINT);       

int N = 1440/Period();//     
int k = 0,            //   
    j=0,
    BarsCount;        //  

k=iBarOfDayReal("0", 0, 0);

BarsCount = N*CountDay; 

for(int i=k;i<=BarsCount;i++)
   {
    SumDiv+=Diver(i);
   }
DivAver = SumDiv/BarsCount;
CurrentDiv = (MathAbs(iClose(Symb1,0,0)/p1-iClose(Symb2,0,0)/p2)/DivAver); 
  
for(i=1;i<=CountDay;i++)
   {
    for(j=k;j<k+N;j++)
     {
      if(Diver(j)/DivAver>DivM) DivM=Diver(j)/DivAver;
     }
    SumDivM+=DivM;
    DivM=0;
    k+=N; 
   } 
DivAverMax=SumDivM/CountDay;

Comment(" ","\n",
        " ","\n",
        "CurrentDiv=",NormalizeDouble(CurrentDiv,4),"\n",
        "DivAverMax=",NormalizeDouble(DivAverMax,4)
        );   
//----
   return(0);
  }
//+-------------------------------------------------------------------------+

double Diver(int z=1)
{
 double diver,Open_Symb1,Open_Symb2;
             
 Open_Symb1 = iOpen(Symb1,0,z)/p1;
 Open_Symb2 = iOpen(Symb2,0,z)/p2;
 diver = MathAbs(Open_Symb1-Open_Symb2);
 return(diver);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 26.02.2008                                                     |
//|   :       .                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    tf -                   (          0 -  )       |
//|    dt -      (          0 -  )           |
//+----------------------------------------------------------------------------+
int iBarOfDayReal(string sy="", int tf=0, datetime dt=0) {
  if (sy=="" || sy=="0") sy=Symbol();
  if (tf<=0) tf=Period();
  if (dt<=0) dt=TimeCurrent();
  if (tf>PERIOD_D1) {
    Print("iBarOfDayReal():       D1");
    return(0);
  }

  int cd=TimeDay(dt);                       //   
  int nb=iBarShift(sy, tf, dt, False);      //   
  int bd=0;                                 //     

  while(TimeDay(iTime(sy, tf, nb))==cd) {
    nb++;
    bd++;
  }

  return(bd);
}